library box2d;

import 'point.dart';
import '../vectors/doublevector.dart';

abstract class Abstract2DBox<N extends num> implements Abstract2DPoint<N> {
	set leftX( N value ) => position.x = value + width;
	set rightX( N value ) => position.x = value - width;
	set topY( N value ) => position.y = value + height;
	set bottomY( N value ) => position.y = value - height;
}


class CustomDouble2DBox extends CustomDouble2DPoint with Abstract2DBox<double> {
	final CustomDouble2DVector _size = new CustomDouble2DVector( 0.0, 0.0 );

	CustomDouble2DVector get size => _size;
}