library doublevector2d;

import 'vector.dart';

class NullDouble2DVector extends Abstract2DVector<double> {
  static final NullDouble2DVector instance = new NullDouble2DVector();

  double get x => 0.0;
  double get y => 0.0;
}


class HorizontalUnitDouble2DVector extends Abstract2DVector<double> {
  static final HorizontalUnitDouble2DVector instance = new HorizontalUnitDouble2DVector();

  double get x => 1.0;
  double get y => 0.0;
  double get length => 1.0;
}


class VerticalUnitDouble2DVector extends Abstract2DVector<double> {
  static final VerticalUnitDouble2DVector instance = new VerticalUnitDouble2DVector();

  double get x => 0.0;
  double get y => 1.0;
  double get length => 1.0;
}


class HorizontalDouble2DVector extends Abstract2DVector<double> {
  double _length;

  HorizontalDouble2DVector( this._length );

  double get x => _length;
  double get y => 0.0;
  double get length => _length;
  set x(double value) => _length = value;
}


class VerticalDouble2DVector extends Abstract2DVector<double> {
  double _length;

  VerticalDouble2DVector( this._length );

  double get x => 0.0;
  double get y => _length;
  double get length => _length;
  set y(double value) => _length = value;
}


class CustomDouble2DVector extends Abstract2DVector<double> {
  double _x, _y;

  CustomDouble2DVector( this._x, this._y );

  set(x, y) {
    _x = x;
    _y = y;
  }

  double get x => _x;
  double get y => _y;
  set x(double value) => _x = value;
  set y(double value) => _y = value;
}
